<?php
####################################################################
# OpenGlobal W3C Ampersands plugin  	           	               #
# Copyright (C) 2012 OpenGlobal   	   	   	   	   	   #
# Homepage   : www.openglobal.co.uk 	   	   	   	   	   		   	   #
# Author     : OpenGlobal    		   	   	   	   	   	   	   	           #
# Version    : 1.0                        	   	    	   	       #
# Created Date  : 2012-01-16       	   	    	   	       #
# License    : http://www.gnu.org/copyleft/gpl.html GNU/GPL        #
####################################################################

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin');

class plgSystemOpenGlobalW3CAmpersands extends JPlugin
{
	function plgSystemOpenGlobalW3CAmpersands(&$subject, $config)
	{
		parent::__construct($subject, $config);
		
		$this->_plugin = JPluginHelper::getPlugin( 'system', 'w3campersands' );
//		$this->_params = new JParameter( $this->_plugin->params );
		
	}
	
	function onAfterRender()
	{
		global $mainframe;
   		$page = JResponse::getBody();

		// A while loop with preg_match is just causing an infinite loop for some reason
		preg_match_all('/(^|\/script>)(.*?)(<script|$)/s', $page, $matches, PREG_SET_ORDER);
		foreach ($matches as $match) {
			$originalString = $match[2];
			$replacementString = preg_replace('/&(?![\w\d#]+;)/', '&amp;', $originalString);
			$page = str_replace($originalString, $replacementString, $page);
		}

		JResponse::setBody($page);

		return true;
	}
}
?>
